/// <reference types="node" />
import { URL } from 'url';
import IHttpResourceLoadDetails from '@unblocked-web/specifications/agent/net/IHttpResourceLoadDetails';
import { IPage } from '@unblocked-web/specifications/agent/browser/IPage';
import { IHooksProvider } from '@unblocked-web/specifications/agent/hooks/IHooks';
import IEmulationProfile from '@unblocked-web/specifications/plugin/IEmulationProfile';
export default class FirstPartyCookiesPlugin implements IHooksProvider {
    readonly emulationProfile: IEmulationProfile;
    static id: string;
    private cookieJar;
    private sitesWithUserInteraction;
    private enableNov2019ITPSupport;
    private enableFeb2020ITPSupport;
    private cookiesPendingSiteInteraction;
    private readonly userInteractionTrigger;
    private readonly logger;
    constructor(emulationProfile: IEmulationProfile);
    onLoadUserProfileCookies(cookies: any, storage: any): void;
    beforeHttpRequest(request: IHttpResourceLoadDetails): Promise<any>;
    beforeHttpResponse(resource: IHttpResourceLoadDetails): Promise<any>;
    onNewPage(page: IPage): Promise<any>;
    websiteHasFirstPartyInteraction(url: URL): void;
    private loadProfileCookies;
    private documentHasUserActivity;
    private setCookie;
    private getCookieHeader;
    private waitForDocumentCookiesLoaded;
    private hasFirstPartyInteractionForDomain;
    private handleNov2019ITPUpdates;
    private isMinimumVersion;
}
